'From Squeak 2.3 beta of Nov 25, 1998 on 1 December 1998 at 6:29:39 pm'!
Object subclass: #FibonacciCalculator
	instanceVariableNames: 'cache m lambda muh '
	classVariableNames: 'Cache '
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #BinaryFibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #LinearFibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #MatrixFibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #RelativeFibonacciCalculator
	instanceVariableNames: 'fn1 fn n '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #Split1FibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #Split2FibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
FibonacciCalculator subclass: #SplitingFibonacciCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!

!FibonacciCalculator commentStamp: 'r++ 12/1/1998 18:29' prior: 0!
My instances know how to compute the Fibonacci Sequence. I'm a the standard recursive but slower FibonacciCalculator, but some of my subclasses are very inteligent.

See coments in my #lambdaMuh, in my subclasses comments (to see something very interesting), and in my subclasses' #positiveF:
method. Heres a table of the running time of the diferent implementations in my P233 and my 486DX-2 80MHz

Time millisecondsToRun: [Split2FibonacciCalculator new emptyClassCache f: 15000] 10014 74937
Time millisecondsToRun: [Split1FibonacciCalculator new emptyClassCache f: 15000] 11246 84189 
Time millisecondsToRun: [SplitingFibonacciCalculator new emptyClassCache f: 15000] 11546 85580
Time millisecondsToRun: [BinaryFibonacciCalculator new emptyClassCache f: 15000] 12738 94873
Time millisecondsToRun: [MatrixFibonacciCalculator new emptyClassCache f: 15000] 20409 151326
!
]style[(184 10 8 19 60 11 108 80 13 80 14 82 13 80 13 80 14)f1,f1LFibonacciCalculator lambdaMuh;,f1,f1LRelativeFibonacciCalculator Comment;,f1,f1LFibonacciCalculator positiveF:. BinaryFibonacciCalculator positiveF:. RelativeFibonacciCalculator positiveF:. Split1FibonacciCalculator positiveF:. Split2FibonacciCalculator positiveF:. SplitingFibonacciCalculator positiveF:. LinearFibonacciCalculator positiveF:. MatrixFibonacciCalculator positiveF:;,f1,f1PTime millisecondsToRun: [Split2FibonacciCalculator new emptyClassCache f: 15000];;,f1,f1PTime millisecondsToRun: [Split1FibonacciCalculator new emptyClassCache f: 15000];;,f1,f1PTime millisecondsToRun: [SplitingFibonacciCalculator new emptyClassCache f: 15000];;,f1,f1PTime millisecondsToRun: [BinaryFibonacciCalculator new emptyClassCache f: 15000];;,f1,f1PTime millisecondsToRun: [MatrixFibonacciCalculator new emptyClassCache f: 15000];;,f1!

!FibonacciCalculator methodsFor: 'accessing' stamp: 'r++ 12/1/1998 18:23'!
f: anIndex 
	" public - Answer the value of the anIndex term of the Fibonacci  
	sequence"
	| answer |
	 
	answer _ self normalize: (anIndex negative
		ifTrue: [ anIndex even
			ifTrue: [(self f: anIndex negated) negated]
			ifFalse: [self f: anIndex negated]]
		ifFalse: [ (self knows: anIndex)
			ifTrue: [self cache at: anIndex]
			ifFalse: [self positiveF: anIndex]]).
	^ answer.! !

!FibonacciCalculator methodsFor: 'accessing' stamp: 'r++ 12/1/1998 18:05'!
lambda

	" public - reffer to coments (within source) of lambdaMuh"
	lambda ifNil: [self lambdaMuh].
	^ lambda.!
]style[(6 51 9 47)f1b,f1,f1LFibonacciCalculator lambdaMuh;,f1! !

!FibonacciCalculator methodsFor: 'accessing'!
m
	^ m! !

!FibonacciCalculator methodsFor: 'accessing'!
m: anIntegerOrNil
	m _ anIntegerOrNil.
	self initializeCache
! !

!FibonacciCalculator methodsFor: 'accessing' stamp: 'r++ 12/1/1998 18:06'!
muh
	" public - reffer to coments (within source) of lambdaMuh"
	muh ifNil: [self lambdaMuh].
	^ muh!
]style[(3 50 9 38)f1b,f1,f1LFibonacciCalculator lambdaMuh;,f1! !

!FibonacciCalculator methodsFor: 'initialization'!
initializeCache
	self zero: 0 one: 1.! !

!FibonacciCalculator methodsFor: 'initialization' stamp: 'Gerardo Richarte 11/11/97 15:59'!
initializeLambdaMuh
	muh _ lambda _ nil.! !

!FibonacciCalculator methodsFor: 'initialization'!
zero: zero one: one
	self initializeLambdaMuh.
	self m
		ifNil: [self cache: self class cache]
		ifNotNil: [self cache:
			(Dictionary new
				at: 0 put: zero;
				at: 1 put: one;
				yourself)]! !

!FibonacciCalculator methodsFor: 'cache'!
cache
	cache ifNil: [self initializeCache].
	^ cache! !

!FibonacciCalculator methodsFor: 'cache'!
cache: aDictionary
	^ cache _ aDictionary! !

!FibonacciCalculator methodsFor: 'cache' stamp: 'r++ 12/1/1998 18:22'!
cacheAdd: aPoint
	self cache at: aPoint x put: aPoint y.
! !

!FibonacciCalculator methodsFor: 'cache' stamp: 'r++ 4/17/98 02:33'!
knows: anIndex 
	" answers whether anIndex is cached or not.
	If the class' cache knows it, get it from there and adapt the modulus
	befor adding to my own cache"
	(self cache includesKey: anIndex)
		ifTrue: [^ true].
	(self class cache includesKey: anIndex)
		ifTrue: 
			[self cacheAdd: anIndex @ (self normalize: (self class cache at: anIndex)).
			^ true].
	^ false! !

!FibonacciCalculator methodsFor: 'private' stamp: 'Gerardo Richarte 11/11/97 16:06'!
normalize: aNumber
	" private - if my m (modulus) is not nil answer aNumber mod m, else answer aNumber"
	^ aNumber 
		perform: (m ifNil: [#+]
				ifNotNil: [#\\])
		with: (m ifNil: [0]
				ifNotNil: [m])! !

!FibonacciCalculator methodsFor: 'manteinment' stamp: 'Gerardo Richarte 11/17/97 06:44'!
emptyCache
	self class emptyCache.
	self cache: nil.
! !

!FibonacciCalculator methodsFor: 'manteinment' stamp: 'Gerardo Richarte 11/11/97 16:27'!
emptyClassCache
	self class emptyCache.
! !

!FibonacciCalculator methodsFor: 'computing' stamp: 'r++ 12/1/1998 18:05'!
lambdaMuh
	" private - calculates lambda and muh, calculating both at once can be done faster. Where
	lambda is the period of Fibonacci's sequence modulus m, and
	muh is the offset where the sequence starts to be periodic.

	It uses the fact that given a sequence (Xn) in a set of m different values defined with 
	Xn+1=f(Xn-1,Xn) if there exist d such that Xn=Xn+d and Xn+1=Xn+d+1 then Xn+d+i=Xn+i for 
	any i >= 0. 
	 
	From a set of m elements can be taken only m^2 different pairs, so for any sequence 
	deffined as (Xn) there exists such d, and it's called lambda. And the smallest n such that 
	Xn+d=Xn is called muh.

	This message is here to be sent to instances of my class that calculates Fibonacci
	sequence modulus some m. (look at #m: and #f:)

	This algorithm is adapted from one in Knuth's Seminumerical Algorithms,
	Exercise 3.1.6 (pg. 7) and it's solution (pg. 517).
	The difference is that here Xn+1=f(Xn-1,Xn) and there it's Xn+1=f(Xn)"

	| n xn1 xn xi1 xi copy |
	n _ 1.
	copy _ self copy.
	[(xn1 _ self f: n - 1) = (copy f: 2 * n - 1) and: [(xn _ (self f: n)) = (copy f: 2 * n)]]
		whileFalse: [n _ n + 1].
	" at this point Xn=X2*n and Xn-1 = X2*n-1, so from this n the sequence will repeat.
	  xn _ Xn, and xn1 _ Xn-1"

	muh _ 0.
	lambda _ n.
	[(self f: muh) = (xi1 _ copy f: n + muh) and: [(self f: muh+1) = (xi _ copy f: n + muh+1)]]
		whileFalse: [
			(lambda > muh and: [xi = xn and: [xn1 = xi1]]) ifTrue: [lambda _ muh].
			muh _ muh + 1].

	" here muh is the smaller value such that Xmuh=Xmuh+n, this is the desired muh,
	  and lambda is the period of the sequence"
! !

!FibonacciCalculator methodsFor: 'computing'!
positiveF: anIndex 
	" public - computes Fibonachi number for index anIndex"
	^ (self f: anIndex - 1) + (self f: anIndex - 2)! !


!BinaryFibonacciCalculator methodsFor: 'computing' stamp: 'r++ 12/1/1998 17:48'!
positiveF: anIndex
	" computes nth element in Fibonacci sequence using the formula
		Fa+b=Fb+1*Fa+Fb*Fa-1

	it starts with Fn-1 and Fn for n=1.
	in each step it computes
		F2n   = (Fn)^2+2Fn*Fn-1
		F2n-1 = (Fn)^2+(Fn-1)^2

	in every step it knows Fa and Fa-1
	where a represents n modulus 2^i and i is the step."

	| n fn fn1 fi fi1 ftemp |
	fn _ self f: 1.		"Fn"
	fn1 _ self f: 0.		"Fn-1"
	fi _ fn1.			"Fa"
	fi1 _ fn.			"Fa-1"
	n _ anIndex.
	[n = 0] whileFalse: [
		n odd ifTrue: [
			ftemp _ (fi*fn)+(fi1*fn1).
			fi _ fi+fi1*fn+(fn1*fi).
			fi1 _ ftemp].
		(n _ n >> 1) = 0 ifFalse: [
			ftemp _ fn*fn.
			fn _ ftemp + (2*fn*fn1).
			fn1 _ ftemp + (fn1*fn1)]].
	^ fi! !


!FibonacciCalculator class methodsFor: 'access'!
cache
	Cache ifNil: [self initializeCache].
	^ Cache! !

!FibonacciCalculator class methodsFor: 'access'!
cacheAdd: aPoint
	self cache at: aPoint x put: aPoint y.! !

!FibonacciCalculator class methodsFor: 'manteinment'!
emptyCache
	" public - empty the cache of Fibonachi Numbers"
	self initializeCache.! !

!FibonacciCalculator class methodsFor: 'initialization'!
initializeCache
	" private - Called to initialize Cache class variable.
	this Cache is a collection of precalculated Fibonachi numbers,
	but are cached only power of two and powers of two minus 1 Fibonachi numbers"
	Cache _	Dictionary new.
	self cacheAdd: 0@0.
	self cacheAdd: 1@1.! !


!LinearFibonacciCalculator methodsFor: 'computing'!
positiveF: n
	| a0 a1 a2 |
	a0 _ self f: 0.
	a1 _ self f: 1.
	n-1 timesRepeat: [ a2 _ a0. a0 _ a1. a1 _ (a1+a2) ].
	^ a1.! !


!MatrixFibonacciCalculator methodsFor: 'computing'!
positiveF: anIndex
	" computes the anIndexth term in Fibonacci sequence using the formula:

	Fn=	Matrix { 1 1 / 1 0 }^n at (1,1)

	and computing M^n by representing n in binary:

		y=Id.
		z=M.

		[n = 0] whileFalse: [
			n odd ifTrue: [y _ y * z].
			z = z * z.
			n << 1]
	"

	| m00 m01 m11 y00 y01 y11 n n00 n01 |
	m00 _ 1.		m01 _ self f: 1.		"m00 m01"
	m11 _ self f: 0.					"m01 m11"
	y00 _ 1.		y01 _ 0.						"y00 y01"
	y11 _ 1.									"y01 y11"
	n _ anIndex.
	[n = 0] whileFalse: [
		n odd ifTrue: [
			n00 _ (y00*m00)+(y01*m01).		n01 _ (y00*m01)+(y01*m11).
			y11 _ (y01*m01)+(y11*m11).
			y00 _ n00.	y01 _ n01].
		n = 1 ifFalse: [
			n00 _ (m00*m00)+(m01*m01).		n01 _ (m00*m01)+(m01*m11).
			m11 _ (m01*m01)+(m11*m11).
			m00 _ n00.	m01 _ n01].
		n _ n >> 1].
	^ y01! !


!RelativeFibonacciCalculator commentStamp: 'r++ 12/1/1998 18:18' prior: 0!
(See #positiveF: comment if you don't know how I do my job)

	I'm not not a very fast implementation for computing a random acces Fibonacci
	Sequence, but if you know that numbers will be requested in order, or from one
	request to the next the distance is not very large, I recomend myself as a good 
	FibonacciCalculator.
	
	For example to compute an intervale of the sequence,

		| fc |
		fc _ RelativeFibonacciCalculator new.
		((0 to: 100) collect: [:eachIndex | fc f: eachIndex]) inspect

	or to compute muh and lambda (See FibonacciCalculator's #lambdaMuh)

		| fc |
		fc _ RelativeFibonacciCalculator new.
		('Calculating 100 lambdas'
			displayProgressAt: Sensor cursorPoint from: 1 to: 100 during: 
				[:bar | (1 to: 100) collect: [:eachIndex | bar value: eachIndex. fc m: eachIndex. fc lambda]]) inspect

	Did you inspect the last chunk? Did you notice something? Lets call Ln this sequence of
	lambdas, I saw (just saw) that for any not prime n, Ln = lcm { divisors of n }. What's that?
	Together with Ariel Pacetti we have already proved this statement.

	Sometimes this is a fast implementation: 

		| fc a b |
		('Timing two implementations'
			displayProgressAt: Sensor cursorPoint from: 1 to: 100 during: [:bar |
				fc _ RelativeFibonacciCalculator new.
				a_(Time millisecondsToRun: [(1 to: 50) collect: [:eachIndex |
						fc m: eachIndex.
						fc lambda.
						bar value: eachIndex]]).
				fc _ Split2FibonacciCalculator new.
				b_(Time millisecondsToRun: [(1 to: 50) collect: [:eachIndex |
						fc m: eachIndex.
						fc lambda.
						bar value: 50+eachIndex]]).
				(Array with: a with: b)]) inspect
!
]style[(5 11 365 113 71 251 297 515)f1,f1LRelativeFibonacciCalculator positiveF:;,f1,f1d		| fc |
		fc _ RelativeFibonacciCalculator new.
		((0 to: 100) collect: [:eachIndex | fc f: eachIndex]) inspect
;;,f1,f1d		| fc |
		fc _ RelativeFibonacciCalculator new.
		('Calculating 100 lambdas'
			displayProgressAt: Sensor cursorPoint from: 1 to: 100 during: 
				[:bar | (1 to: 100) collect: [:eachIndex | bar value: eachIndex. fc m: eachIndex. fc lambda]]) inspect
;;,f1,f1d		| fc a b |
		('Timing two implementations'
			displayProgressAt: Sensor cursorPoint from: 1 to: 100 during: [:bar |
				fc _ RelativeFibonacciCalculator new.
				a_(Time millisecondsToRun: [(1 to: 50) collect: [:eachIndex |
						fc m: eachIndex.
						fc lambda.
						bar value: eachIndex]]).
				fc _ Split2FibonacciCalculator new.
				b_(Time millisecondsToRun: [(1 to: 50) collect: [:eachIndex |
						fc m: eachIndex.
						fc lambda.
						bar value: 50+eachIndex]]).
				(Array with: a with: b)]) inspect
;;!

!RelativeFibonacciCalculator methodsFor: 'accessing'!
fn1: anInteger 
	^ fn1 _ self normalize: anInteger! !

!RelativeFibonacciCalculator methodsFor: 'accessing'!
fn: anInteger
	^ fn _ self normalize: anInteger.! !

!RelativeFibonacciCalculator methodsFor: 'accessing'!
m: anInteger
	super m: anInteger.
	self n: 1! !

!RelativeFibonacciCalculator methodsFor: 'accessing'!
n: anInteger
	| fc |
	n _ anInteger.
	fc _ BinaryFibonacciCalculator new m: self m.
	self fn1: (fc f: n-1).
	^ self fn: (fc f: n).! !

!RelativeFibonacciCalculator methodsFor: 'initialization' stamp: 'Gerardo Richarte 11/12/97 05:15'!
initializeIfNotDone
	n ifNil: [self n: 1].! !

!RelativeFibonacciCalculator methodsFor: 'computing' stamp: 'r++ 4/17/98 02:13'!
positiveF: anIndex 
	" Computes the anIdnexth number in Fibonacci sequence.  
	  My instances know a given n, Fn and Fn-1 (n,fn,fn1), when this message is sent  
	  I use Fn+1=Fn+Fn-1 or Fn-2=Fn-Fn-1 whether anIndex > n or anIndex < n to compute  
	  the requested Fn, then I save this n, Fn and Fn-1 as current state."
	| fnew |
"	(anIndex - n) abs > (4*(anIndex - n) abs highBit)"
"		ifTrue: [^ self n: anIndex]."
	self initializeIfNotDone.
	[n < anIndex]
		whileTrue: 
			[fnew _ fn + fn1.
			self fn1: fn.
			self fn: fnew.
			n _ n + 1].
	[n > anIndex]
		whileTrue: 
			[fnew _ fn - fn1.
			self fn: fn1.
			self fn1: fnew.
			n _ n - 1].
	^ fn! !

!RelativeFibonacciCalculator methodsFor: 'copying'!
copy
	^ self class new m: self m! !


!Split1FibonacciCalculator methodsFor: 'initilization' stamp: 'Gerardo Richarte 11/12/97 05:08'!
zero: zero one: one
	super zero: zero one: one.
	self
		cacheAdd: 2@(self normalize: (self f: 0)+(self f: 1));
		cacheAdd: 3@(self normalize: (self f: 1)+(self f: 2)).! !

!Split1FibonacciCalculator methodsFor: 'computing'!
positiveF: anInteger 
	"Answer the value of the anIntegerth term of the Fibonacci sequence by Andres Valloud"
	| msb storeOnCache a b answer |
	msb _ 1 << (anInteger highBit - 1).
	storeOnCache _ anInteger - msb <= 1.
	a _ storeOnCache
				ifTrue: [anInteger >> 1]
				ifFalse: [msb].
	b _ anInteger - a.
	answer _ (self f: a + 1)
				* (self f: b) + ((self f: a)
					* (self f: b - 1)).
	storeOnCache ifTrue: [self cacheAdd: anInteger @ answer].
	^ answer! !


!Split2FibonacciCalculator methodsFor: 'initialization' stamp: 'Gerardo Richarte 11/12/97 05:01'!
zero: zero one: one
	super zero: zero one: one.
	self
		cacheAdd: 2@(self normalize: (self f: 0)+(self f: 1));
		cacheAdd: 3@(self normalize: (self f: 1)+(self f: 2)).! !

!Split2FibonacciCalculator methodsFor: 'computing'!
positiveF: n 
	"computes fibonacci sequence at index n. It uses the formula:  Fa+b = Fb+1*Fa+Fb*Fa-1
	and works spliting anIndex in n=a+b, where a is the greater power of two wich is
	smaller than anIndex, then it computes (recursively) Fa and Fb and uses the formula
	to compute Fn=Fa+b"

	| b a fa fa1 |
	b _ n - (a _ 1 << ((n - 1) highBit - 1)).
	self cacheAdd: a - 1 @ (fa1 _ self f: a - 1).
	self cacheAdd: a @ (fa _ self f: a).
	^ (self f: b + 1) * fa + (fa1 * (self f: b))! !


!SplitingFibonacciCalculator methodsFor: 'computing'!
positiveF: n 
	"computes fibonacci sequence at index n. 
	  it uses the formula: 
	Fa+b = Fb+1*Fa+Fb*Fa-1 = (Fb-1+Fb)*Fa+Fb*Fa-1 = Fb-1*Fa+Fb*(Fa+Fa-1) 
	and works spliting anIndex in n=a+b, 
	where a is the greater power of two wich is smaller than anIndex, 
	the it computes (recursively) Fa and Fb and uses the formula to 
	compute Fn=Fa+b"
	| b a fa fa1 |
	b _ n - (a _ 1 << ((n - 1) highBit - 1)).
	self cacheAdd: a @ (fa _ self f: a).
	self cacheAdd: a - 1 @ (fa1 _ self f: a - 1).
	^ (self f: b - 1) * fa + (fa + fa1 * (self f: b))! !


FibonacciCalculator removeSelector: #initialize!
FibonacciCalculator removeSelector: #menuReset:!
FibonacciCalculator removeSelector: #addCustomMenuItems:hand:!
FibonacciCalculator removeSelector: #max!
FibonacciCalculator removeSelector: #max:!
FibonacciCalculator removeSelector: #forkF:!
FibonacciCalculator removeSelector: #drawOn:!
FibonacciCalculator removeSelector: #min!
FibonacciCalculator removeSelector: #scaleIndex:!
FibonacciCalculator removeSelector: #menuF:!
FibonacciCalculator removeSelector: #min:!
FibonacciCalculator removeSelector: #stepTime!
FibonacciCalculator removeSelector: #drawCacheOn:!
